/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
*******************************************************************************
*/

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <string.h>
#include <sys/types.h>

#include <mplib1/dumphex.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

static char *find_eos( char *where )
{
    return(where+strlen(where));
}

int
do_hex_dump( FILE *fp, off_t curoff, const char *where, ssize_t how_much )
{
    char linebuf[80];
    char charbuf[20];
    int count16,i;
    char *eos;
/*fprintf(fp, "hex_dump: %p %d\n", where, how_much );*/
    count16 = ((int)curoff & 0x0f);
    while (how_much || count16)
    {
	sprintf( linebuf, "%08x  ", (int)curoff );
	for (i=0;i<16;i++)
	{
	    eos = find_eos(linebuf);
	    charbuf[i] = ' ';
	    if (i<count16)
	    {
		/* blank area */
		sprintf(eos, ".. " );
	    }else
	    {
		/* output the normal stuff */
		if (how_much)
		{
		    sprintf(eos,"%02x ", *where & 0xff );
		    if (*where >= ' ' && *where<0x7f)
		    {
			charbuf[i] = *where;
		    }
		    how_much--;
		}else
		    sprintf(eos, ".. " );
		where++;
		count16++;
		curoff++;
		count16 &= 0x0f;
	    }
	}
	charbuf[16] = '\0';
	fprintf(fp, "%s  '%s'\n", linebuf, charbuf );
    };
    return(1);
}

int
hex_dump( FILE *fp, const char *where, ssize_t how_much )
{
    return(do_hex_dump( fp, 0, where, how_much ));
}

/* -- End of File -- */
