/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
*******************************************************************************
*/

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <pwd.h>
#include <time.h>
#include <string.h>
#include <memory.h>

#include <mplib1/mplib1_config.h>
#include <mplib1/timestamp.h>
#include <mplib1/pid_check.h>
#include <mplib1/fprintfile.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

static char unknown[]="UNKNOWN";
static char *me_name=NULL;

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

char *
get_my_uname( void )
{
    struct passwd *pwd;

    if (me_name==NULL)
    {
	pwd = getpwuid(getuid());
	if (pwd)
	{
	    me_name = strdup( pwd->pw_name );
	}else
	{
	    me_name = malloc( PID_STR_LEN + 2 );
	    if (me_name)
		sprintf( me_name, "[%d]", (int)getuid() );
	}
	if (me_name==NULL)
	    me_name = unknown;
    }
    return(me_name);
}

/* -- End of File -- */
