/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
*******************************************************************************
*/

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <signal.h>
#include <string.h>
#include <errno.h>

#include <mplib1/mplib1_config.h>
#include <mplib1/pid_check.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

void
gen_pid_str( char *buf, pid_t the_pid )
{
    if (buf)
    {
	sprintf( buf, "%ld", (long)the_pid );
    }
    return;
}

int
is_pid_dead( pid_t the_pid )
{
    int rv;
    rv = kill( the_pid, 0 );
    if (rv!=0 && errno!=ESRCH)
	rv=0;
    return(rv);
}

/* -- End of File -- */
