/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
*******************************************************************************
*/

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <pwd.h>
#include <time.h>
#include <string.h>
#include <stdarg.h>
#include <memory.h>

#include <mplib1/mplib1_config.h>
#include <mplib1/timestamp.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

struct timeval *
get_current_timeval( struct timeval *tvp )
{
    if (tvp)
    {
#ifdef H_GETTIMEOFDAY_2_NULL
	gettimeofday( tvp, NULL );
#else
#ifdef H_GETTIMEOFDAY_2_PARAMS
	struct timezone my_tz;

	my_tz.tz_minuteswest = 0;
	my_tz.tz_dsttime = 0;

	gettimeofday( tvp, &my_tz );
#else
	gettimeofday( tvp );
#endif
#endif
    }
    return(tvp);
}

char *
build_timestamp_str( struct timeval *tvp, char *buf )
{
    char hunds[10];
    struct tm *tim;
    if (tvp && buf)
    {
	tim = gmtime((time_t *)&tvp->tv_sec);

	/* Change to conform to ISO 8601 / EN 28601 */
	strftime( buf, TIMESTAMP_STR_SZ, "%Y-%m-%d %H:%M:%S", tim );
	sprintf( hunds, ".%02dZ", (int)(tvp->tv_usec / 10000L) );

	strcat( buf, hunds );
    }
    
    return(buf);
}

char *
make_timestamp_str( char *buf )
{
    static char log_str[TIMESTAMP_STR_SZ];
    struct timeval tval;
    get_current_timeval( &tval );
    if (buf==NULL)
	buf = log_str;
    (void)build_timestamp_str( &tval, buf );
    return(buf);
}

/* -- End of File -- */
