/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
*******************************************************************************
*/

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <sys/time.h>

#include <mplib1/mplib1_config.h>

#include "../include/bpo_internal.h"
#include <mplib1/bpo.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

#ifndef BPO_LOCK_NAP_USEC
#define BPO_LOCK_NAP_USEC	5000
#endif

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

int
bpo_nap_a_while( long secs, long usecs )
{
    struct timeval my_nap;

    my_nap.tv_sec = secs;
    my_nap.tv_usec = (suseconds_t)usecs;

    return (select( 0, NULL, NULL, NULL, &my_nap ));

}

int
bpo_take_a_nap( void )
{
    return(bpo_nap_a_while( 0, BPO_LOCK_NAP_USEC ));
}


/* -- End of File -- */
