/*
*******************************************************************************
*  Copyright (c) 1997 Martin Poole                            *
*******************************************************************************
**
*******************************************************************************
*/

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#include <mplib1/mplib1_config.h>
#include <mplib1/dl_list.h>
#include <mplib1/cfg_file.h>
#include <include/cfg_file_internal.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

static char list_alt[]="alt_config";
static char key_1[]="key_1";
static char val_1[]="val_1";
static char val_2[]="val_2";

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

static void
do_cfg_test( void )
{
    struct config_list *clp;
    /* First test that we can create the default list holder */
    clp = get_config_list( NULL, 1 );
    printf( "get_config_list( NULL, 1 )=%p\n", clp );
    /* Now to test the various parts of the config storage mech */
    printf( "set_config_string( key_1, val_1 )=%d\n",
	    set_config_string( key_1, val_1 ) );
    printf( "get_config_string( key_1 )=%s\n",
	    get_config_string( key_1 ) );
    printf( "set_private_string( list_alt, key_1, val_2 )=%d\n",
	    set_private_string( list_alt, key_1, val_2 ) );
    printf( "get_private_string( list_alt, key_1 )=%s\n",
	    get_private_string( list_alt, key_1 ) );
    printf( "get_config_string( key_1 )=%s\n",
	    get_config_string( key_1 ) );
    return;
}

int
main( int argc, char *argv[] )
{
    do_cfg_test( );
    return(0);
}

/* -- End of File -- */
